//@ts-check
"use strict";

/**
 * @typedef Target
 * @type {object}
 * @property {PIXI.Point} pos
 * @property {PIXI.Sprite} sprite
 */

/** @returns {Target} */
function createTarget() {
  const sprite = new PIXI.Sprite(app.loader.resources["inGame/target.png"].texture);
  sprite.anchor.set(0.5, 0.5);
  inGame.pixiRoot.addChild(sprite);

  return { pos: new PIXI.Point(0, 0), sprite };
}

function updateTarget(dt) {
  const canvasRect = app.renderer.view.getBoundingClientRect();
  const { mouse } = inGame.input;

  const gameMouseX = (mouse.x - canvasRect.left) * game.width / canvasRect.width;
  const gameMouseY = (mouse.y - canvasRect.top) * game.height / canvasRect.height;
  inGame.target.sprite.position.set(gameMouseX, gameMouseY);

  inGame.target.pos.x = (gameMouseX - game.width / 2) / tileSize + inGame.camera.pos.x;
  inGame.target.pos.y = (gameMouseY - game.height / 2) / tileSize + inGame.camera.pos.y;
}
